%%%%%%%%%%%%%%% CAPITOL 13b: RESOLUCIO AMB QUANTIFICADORS %%%%%%%%%%%%


% 13.1 Regla de Skolem

  !X?Y?Z!U?V (P(X,Y,Z) --> Q(Z,U,V)) premissa;
  !X?Z!U?V (P(X,f(X),Z) --> Q(Z,U,V));          % skolem Y:=f(X)
  !X!U?V (P(X,f(X),g(X)) --> Q(g(X),U,V));      % skolem Z:=g(X)
  !X!U (P(X,f(X),g(X)) --> Q(g(X),U,h(U,X))).   % skolem V:=h(X,U)


% 13.2 Regla de Substitucio

  !X!Y!Z (P(X,a)/\Q(Y,Z) --> P(Z,Y)) premissa;
  P(X,a)/\Q(Y,Z) --> P(Z,Y);             % Especificacio universal: pertot X,Y,Z
  P(a,a)/\Q(Y,Z) --> P(Z,Y);             % Substitucio X:=a
  P(a,a)/\Q(Y,f(T)) --> P(f(T),Y);       % Substitucio Z:=f(T) pertot T
  P(a,a)/\Q(T,f(T)) --> P(f(T),T);       % Substitucio Y:=T
  !T (P(a,a)/\Q(T,f(T)) --> P(f(T),T)).  % Generalitzacio universal


% 13.3 Metode de resolucio

  % Exemple 1
  % Proveu:  P(f(a),b) /\ !X!Z(P(f(X),Z)\/Q(X,g(X))) ==> ?Y Q(a,Y)

  % normalitzacio
  P1: P(f(a),b) premissa;

  P2: !X?Y!Z(P(f(X),Z)-->Q(X,Y)) premissa;
      !X?Y!Z(P(f(X),Z)\/Q(X,Y));
      !X!Z(P(f(X),Z)\/Q(X,g(X)));                    % skolem Y:=g(X)

  P3: ?Y Q(a,Y) premissa;
      !Y Q(a,Y);

  % clausules
  C1: P(f(a),b) per P1;
  C2: P(f(X),Z)\/Q(X,g(X)) per P2;                   % pertot X,Z
  C3: Q(a,Y) per P3;                                 % pertot Y

  % resolucio
  R1: (P(f(X),Z)\/Q(X,g(X))) /\ Q(a,Y1) per C2,C3;
      (P(f(a),Z)\/Q(a,g(a))) /\ Q(a,Y1);            % Substitucio X:=a
      (P(f(a),Z)\/Q(a,g(a))) /\ Q(a,g(a));          % Substitucio Y1:=g(a)
      P(f(a),Z);                                     % resolucio

  R2: P(f(a),Z) /\ P(f(a),b) per R1,C1;
      P(f(a),b) /\ P(f(a),b);                        % Substitucio Z:=b
      0.                                              % resolucio


  % Exemple 2
  % Proveu: !x?y (P(x)/\Q(y)) ==> ?y!x (P(x)/\Q(y))

  !x?y (P(x)/\Q(y)) --> ?y!x (P(x)/\Q(y))
  demostracio
    % normalitzacio
    P1: !x?y (P(x)/\Q(y)) hipotesi;
        !x (P(x)/\Q(f(x)));                  % skolem y:=f(x)

    P2: ?y!x (P(x)/\Q(y)) suposicio;
        !y!x (P(x)/\Q(y));
        !y?x (P(x)/\Q(y));
        !y?x (P(x)\/Q(y));
        !y (P(g(y))\/Q(y));                % skolem x:=g(x)

    % clausules
    C1: P(x)/\Q(f(x)) per P1;
        P(x);                                % pertot x

    C2: P(x)/\Q(f(x)) per P1;
        Q(f(x));

    C3: P(g(y))\/Q(y) per P2;              % pertot y

    % resolucio
    R1: (P(g(y))\/Q(y))/\P(x1) per C3,C1;  % pertot x1
        (P(g(y))\/Q(y))/\P(g(y));          % substitucio x1:=g(y)
        Q(y);

    R2: Q(y)/\Q(f(x2)) per R1,C2;           % pertot x2
        Q(f(x2)) /\Q(f(x2));                % substitucio y:=f(x2)
        0;
  fi.
