%%%%%%%%%% EXEMPLES: REFUTACIONS %%%%%%%%%

%%% Refuteu: (A-->B\/C)/\A/\C --> (B\/C)

  A:=0; 
  B:=1;
  C:=0;

  (A-->B\/C)/\A/\C --> (B\/C)
  = (0-->1\/0)/\0/\0 --> (1\/0)
  = (0-->1)/\1/\1-->1
  = 1/\1/\1-->0
  = 1-->0
  = 0.



%%% Refuteu: !X?Y P(X,Y) --> ?Y!X P(X,Y) 

  Univers:={a,b};
  P(a,a):=1;
  P(a,b):=0;
  P(b,a):=0;
  P(b,b):=1;

  !X?Y P(X,Y) --> ?Y!X P(X,Y)  
  = ?Y P(a,Y) /\ ?Y P(b,Y) --> !X P(X,a) \/ !X P(X,b)
  = (P(a,a)\/P(a,b)) /\ (P(b,a)\/P(b,b)) --> (P(a,a)/\P(b,a)) \/ (P(a,b)/\P(b,b))
  = (1\/0) /\ (0\/1) --> (1/\0) \/ (0/\1)
  = 1 /\ 1 --> 0 \/ 0
  = 1 --> 0
  = 0.



%%% Refuteu: ?X P(X,c) --> ?X?Y(P(X,Y)/\P(Y,c))

  Univers:={a,b};
  c:=b;
  P(a,a):=0;
  P(a,b):=1;
  P(b,a):=0;
  P(b,b):=0;

  ?X P(X,c) --> ?X?Y(P(X,Y)/\P(Y,c))  
  = P(a,c)\/P(b,c) --> ?X?Y(P(X,Y)/\P(Y,c))  
  = P(a,b)\/P(b,b) --> ?X?Y(P(X,Y)/\P(Y,c))  
  = 1\/0 --> ?X?Y(P(X,Y)/\P(Y,c))  
  = 1 --> ?X?Y(P(X,Y)/\P(Y,c))
  = 1 --> ?X?Y(P(X,Y)/\P(Y,c))  
  = 1 --> ?X((P(X,a)/\P(a,c))\/(P(X,b)/\P(b,c)))
  = 1 --> ?X((P(X,a)/\P(a,b))\/(P(X,b)/\P(b,b)))
  = 1 --> ?X((P(X,a)/\1)\/(P(X,b)/\0))
  = 1 --> ?X(P(X,a)\/0)
  = 1 --> ?X P(X,a)
  = 1 --> P(a,a)\/P(b,a)
  = 1 --> 0\/0
  = 1 --> 0
  = 0.



%%%%% (A-->B\/C)/\(C-->A\/B) =/=> B-->C

  A := 0;   % Contraexemple
  B := 1;
  C := 0;

  (A-->B\/C)/\(C-->A\/B) --> (B-->C)
  = (0-->1\/0)/\(0-->0\/1) --> (1-->0)
  = (0-->0\/0)/\(1-->1\/1) --> 0
  = (0-->0)/\(1-->1) --> 0
  = 1/\1 -->0
  = 1-->0
  = 0.



%%%%%% ?X(P(X)/\Q(X))/\?X(Q(X)/\F(X)) =/=> ?X(P(X)/\F(X))

  Univers:={a,b};       % Contraexemple
  P(a):=1;  P(b):=0;
  Q(a):=0;  Q(b):=1;
  F(a):=1;  F(b):=0;

  ?X(P(X)/\Q(X)) /\ ?X(Q(X)/\F(X)) --> ?X(P(X)/\F(X))
  = ((P(a)/\Q(a))\/(P(b)/\Q(b))) /\ ?X(Q(X)/\F(X)) --> ?X(P(X)/\F(X))
  = ((1/\0)\/(0/\1)) /\ ?X(Q(X)/\F(X)) --> ?X(P(X)/\F(X))
  = ((1/\1)\/(0/\0)) /\ ?X(Q(X)/\F(X)) --> ?X(P(X)/\F(X))
  = (1\/0) /\ ?X(Q(X)/\F(X)) --> ?X(P(X)/\F(X))
  = 1 /\ ?X(Q(X)/\F(X)) --> ?X(P(X)/\F(X))
  = ?X(Q(X)/\F(X)) --> ?X(P(X)/\F(X))
  = (Q(a)/\F(a))\/(Q(b)/\F(b)) --> ?X(P(X)/\F(X))
  = (0/\1)\/(1/\0) --> ?X(P(X)/\F(X))
  = (0/\0)\/(1/\1) --> ?X(P(X)/\F(X))
  = 0\/1 --> ?X(P(X)/\F(X))
  = 1 --> ?X(P(X)/\F(X))
  = 1 --> (P(a)/\F(a))\/(P(b)/\F(b))
  = 1 --> (1/\1)\/(0/\0)
  = 1 --> (1/\0)\/(0/\1)
  = 1 --> 0\/0
  = 1 --> 0
  = 0.




%%%%% !x?y P(x,y) =/=> ?x P(x,f(x))

  Univers:={a,b};       % Contraexemple
  f(a):=a;
  f(b):=a;
  P(a,a):=0; P(a,b):=1;
  P(b,a):=0; P(b,b):=1;

  !x?y P(x,y) --> ?x P(x,f(x))
  = (?y P(a,y))/\(?y P(b,y)) --> ?x P(x,f(x)) 
  = (P(a,a)\/P(a,b))/\(P(b,a)\/P(b,b)) --> ?x P(x,f(x))
  = (0\/1)/\(0\/1) --> ?x P(x,f(x))
  = 1/\1 --> ?x P(x,f(x))
  = 1 --> ?x P(x,f(x))
  = 1 --> ?x P(x,f(x)) 
  = 1 --> P(a,f(a))\/P(b,f(b))
  = 1 --> P(a,a)\/P(b,a)
  = 1 --> 0\/0
  = 1 --> 0
  = 0.


%%%% (A/\B-->C)/\(C-->D) =/=> B-->D

  A:=0;      % Contraexemple
  B:=1;
  C:=0;
  D:=1;

  (A/\B-->C)/\(C-->D) --> (B-->D)
  = (0/\1-->0)/\(0-->1) --> (1-->1)
  = (0/\0-->0)/\(0-->0) --> (1-->0)
  = (0-->0)/\1 --> 0
  = 1/\1 --> 0
  = 1 --> 0
  = 0.



%%%% ?X(A(X)/\B(X)) 
%%%% /\ !X(A(X)-->C(X)) 
%%%% /\ ?X(A(X)/\B(X)) 
%%%% =/=> !X(B(X)-->C(X))

  Univers:={a,b,c};              % Contraexemple
  A(a):=0; A(b):=1; A(c):=1;
  B(a):=1; B(b):=1; B(c):=0;
  C(a):=0; C(b):=1; C(c):=1;

  ?X(A(X)/\B(X)) 
  /\ !X(A(X)-->C(X)) 
  /\ ?X(A(X)/\B(X)) 
  --> !X(B(X)-->C(X))

  = ((A(a)/\B(a))\/(A(b)/\B(b))\/(A(c)/\B(c))) 
    /\ ((A(a)-->C(a))/\(A(b)-->C(b))/\(A(c)-->C(c))) 
    /\ ((A(a)/\B(a))\/(A(b)/\B(b))\/(A(c)/\B(c))) 
    --> (B(a)-->C(a))/\(B(b)-->C(b))/\(B(c)-->C(c))

  = ((0/\1)\/(1/\1)\/(1/\0))
    /\ ((0-->0)/\(1-->1)/\(1-->1))
    /\ ((0/\1)\/(1/\1)\/(1/\0))
    --> (1-->0)/\(1-->1)/\(0-->1)

  = (0\/1\/0)
    /\ (1/\1/\1)
    /\ ((0/\0)\/(1/\0)\/(1/\1))
    --> 0/\1/\1

  = 1 /\ 1 /\ (0\/0\/1) --> 0
  = 1 /\ 1 /\ 1 --> 0
  = 1 --> 0
  = 0.

    
      
%%%%%% P(a)
%%%%%% /\ !X(P(X) --> S(f(X)))
%%%%%% /\ !X(S(X) --> P(f(X))) 
%%%%%% =/=> S(f(f(a)))

  Univers:={0,1};        % Contraexemple
  a:=0;
  f(0):=1; 
  f(1):=0;
  P(0):=1;   S(0):=0;
  P(1):=0;   S(1):=1;

  P(a)
  /\ !X(P(X) --> S(f(X)))
  /\ !X(S(X) --> P(f(X))) 
  --> S(f(f(a)))

  = P(0)
    /\ ((P(0) --> S(f(0))) /\ (P(1) --> S(f(1))))
    /\ ((S(0) --> P(f(0))) /\ (S(1) --> P(f(1))))
    --> S(f(f(0)))

  = 1
    /\ ((P(0) --> S(1)) /\ (P(1) --> S(0)))
    /\ ((S(0) --> P(1)) /\ (S(1) --> P(0)))
    --> S(f(1))

  = 1
    /\ ((1 --> 1) /\ (0 --> 0))
    /\ ((0 --> 0) /\ (1 --> 1))
    --> S(0)

  = 1 /\ (1/\1) /\ (1/\1) --> 0
  = 1 /\ 1 /\ 1 --> 0
  = 1 --> 0
  = 0.
