%%%%%%%%%%%%%% EXEMPLES: VALIDACIONS %%%%%%%%%%%


%%% Proveu: (P-->Q)/\(P/\R)/\(Q-->R\/S) ==> R/\(P\/Q)/\S

  1: P-->Q     Premissa;
  2: P/\R      Premissa;
  3: Q-->R\/S  Premissa;

  4: R per 2;

  5: P       per 2;
  6: Q      per 5,1;
  7: P\/Q  per 6;

  8: R\/S  per 6,3;
  9: S     per 8,4;

 10: R/\(P\/Q)/\S  per 4,7,9.





%%% Proveu: Q(f(f(b))) /\ !X(P(X)-->Q(f(X))) ==> ?XP(f(X))

  1: Q(f(f(b)))           Premissa;
  2: !X(P(X)-->Q(f(X)))    Premissa;
  3: P(f(b))-->Q(f(f(b)))  per 2;     % X:=f(b)
  4: P(f(b))              per 3,1;
  5: ?XP(f(X))            per 4.     % X:=b




%%% Proveu: !x P(x) ==> ?x P(x)
  !x P(x) premissa;
  P(c);    
  ?x P(x).



%%% Proveu: ?x P(f(x)) ==> (A \/ ?y P(y)) /\ (B \/ ?y P(y))

  1: ?x P(f(x))    Premissa;
     P(f(c));                 % per algun c
     ?y P(y);                 % y:=f(c)
  2: A \/ ?y P(y)  per 1;
  3: B \/ ?y P(y)  per 1;
  4: (A \/ ?y P(y)) /\ (B \/ ?y P(y))  per 2,3.



%%% Proveu: !x(P(x)/\Q(x)) ==> !x(P(x)\/Q(x))

  !x(P(x)/\Q(x)) premissa;
  P(t)/\Q(t);    % per tot t
  P(t);
  P(t)\/Q(t);
  !x(P(x)\/Q(x)).




%%% Proveu: !X (A/\P(X)) ==> B \/ ?X P(f(X))

  !X (A/\P(X))   premissa;
  A/\P(f(c));    % X:=f(c)
  P(f(c)); 
  P(f(c));
  ?X P(f(X));      % X:=c
  B \/ ?X P(f(X)).




%%% Proveu: ?x P(x) ==> !x P(x)

  1: ?x P(x)  Premissa;
  2: !x P(x)
     Demostracio
       3: !x P(x)    Suposicio;
       4: !x P(x)      per 3;
       5: P(c)        per 1;     % per algun c
       6: P(c)         per 4;     % x:=c
       7: P(c)/\P(c)  per 5,6;
     Fi.



%%% Proveu: !x (P(x) --> A) ==> ?x P(x) --> A

  1: !x (P(x) --> A)    Premissa;
  2: ?x P(x) --> A
     Demostracio
       3: ?x P(x)     Hipotesi;
       4: A          Suposicio;
       5: P(c)        per 3;      % per algun c
       6: P(c) --> A  per 1;      % x:=c
       7: A           per 5,6;
       8: A/\A       per 7,4;
     Fi.



%%% Proveu: !x (A \/ P(x)) ==> A \/ !x P(x) 

  1: !x (A \/ P(x))  Premissa;
  2: A \/ !x P(x) 
     Demostracio
       3: A --> A \/ !x P(x)
          Demostracio
            4: A             Hipotesi;
            5: A \/ !x P(x)  per 4
          Fi;

       6: A --> A \/ !x P(x)
          Demostracio
            7: A            Hipotesi;
            8: A\/P(t)       per 1;    % per qualsevol t
            9: P(t)          per 7,8;
           10: !x P(x)       per 9;    % t era un generalitzador
           11: A \/ !x P(x)  per 10
          Fi;

      12: A \/ !x P(x)  per 3,6
     Fi.



%%% Proveu: ?x P(x) <==> !x P(x)

    % ?x P(x) ==> !x P(x)
    1: ?x P(x)  Premissa;
    2: P(t)     % per qualsevol t
       Demostracio
         3: P(t)                 Suposicio;
         4: ?x P(x)              per 3;       % x:=t
         5: ?x P(x) /\ ?x P(x)  per 1,4
       Fi;
    6: !x P(x)  per 2.  % t era un generalitzador

    % !x P(x) ==> ?x P(x)
    1: !x P(x)  Premissa;
    2: ?x P(x)
       Demostracio
         3: ?x P(x)      Suposicio;
         4: P(s)         per 3;       % per algun s
         5: P(s)        per 1;       % x:=s
         6: P(s)/\P(s)  per 4,5
       Fi.



%%% Proveu: ?x P(x) --> Q <==> !x (P(x) --> Q)

    % ?x P(x) --> Q ==> !x (P(x) --> Q)
    1: ?x P(x) --> Q   Premissa;
    2: P(t) --> Q
       Demostracio
         3: P(t)     Hipotesi;
         4: ?x P(x)  per 3;
         5: Q        per 4,1;
       Fi;
    6: !x (P(x) --> Q)  per 2.


    % !x (P(x) --> Q) ==> ?x P(x) --> Q
    1: !x (P(x) --> Q)  Premissa;
    2: ?x P(x) --> Q
       Demostracio
         3: ?x P(x)     Hipotesi;
         4: P(s)        per 3;
         5: P(s) --> Q  per 1;
         6: Q           per 4,5;
       Fi.



%%% Proveu: ?x P(x) <--> !x P(x)

    1: ?x P(x) --> !x P(x)
       Demostracio
         2: ?x P(x)   Hipotesi;
         3: P(t)
            Demostracio
              4: P(t)   Suposicio;
              5: P(t)     per 4;
              6: ?x P(x)  per 5;
              7: ?x P(x) /\ ?x P(x)  per 6,2
            Fi;
         8: !x P(x)  per 3;
       Fi;

    9: !x P(x) --> ?x P(x)
       Demostracio
         10: !x P(x)     Hipotesi;
         11: ?x P(x)    Suposicio;
         12: ?x P(x)      per 11;
         13: P(s)         per 12;
         14: P(s)        per 10;
         15: P(s)/\P(s)  per 13,14;
       Fi;

   16: ?x P(x) <--> !x P(x)  per 1,9.





%%% Proveu: (P<-->Q/\R) /\ ((R\/Q)-->S) /\ (T-->M) /\ (M-->N) /\ (T-->S) ==> P-->N

  1: P<-->Q/\R          Premissa;
  2: (R\/Q)-->S     Premissa;
  3: (T-->M)/\(M-->N)  Premissa;
  4: T-->S              Premissa;
  5: P-->N
     Demostracio
        6: P          Hipotesi;
        7: (P-->Q/\R) /\ (Q/\R-->P) per 1;
        8: P-->Q/\R   per 7;
        9: Q/\R       per 6,8;
       10: R/\Q-->S  per 2;
       11: R/\Q       per 9;
       12: S         per 10,11;
       13: T         per 12,4;
       14: T-->M     per 3;
       15: M          per 13,14;
       16: M-->N      per 3;
       17: N          per 15,16;
     Fi.




%%% Proveu:
%%% !X(?Z P(X,Z) --> ?Y(Q(Y)/\R(X,Y)))
%%% /\ !Y(Q(Y) --> !X(R(X,Y)-->Q(X)))
%%% ==> ?XQ(X) --> ?YP(Y,Y)

  1: !X(?Z P(X,Z) --> ?Y(Q(Y)/\R(X,Y))) Premissa;
  2: !Y(Q(Y) --> !X(R(X,Y)-->Q(X)))     Premissa;
  3: ?XQ(X) --> ?YP(Y,Y)
     Demostracio
       4: ?XQ(X)     Hipotesi;
          Q(a);

       5: ?YP(Y,Y)  Suposicio;
          !Y P(Y,Y);                             
          P(a,a);                                

       6: ?Z P(a,Z) --> ?Y(Q(Y)/\R(a,Y))  per 1;  
          ?Y(?Z P(a,Z) --> Q(Y)/\R(a,Y));            
          ?Z P(a,Z) --> Q(b)/\R(a,b);                
          !Z(P(a,Z) --> Q(b)/\R(a,b));               
          P(a,a) --> Q(b)/\R(a,b);                   

       7: Q(b)/\R(a,b)                    per 5,6;   
       8: Q(b)                            per 7;
       9: R(a,b)                          per 7;

      10: Q(b) --> !X(R(X,b)-->Q(X))      per 2;
  
      11: !X(R(X,b)-->Q(X))               per 8,10; 
          R(a,b)-->Q(a);                            

      12: Q(a)                            per 9,11;
      13: Q(a)/\Q(a)                     per 12,4;
     Fi.

