%%%%%%%%%%%%% EXEMPLES: METODE DE RESOLUCIO %%%%%%%%%%%%%%%%

%%% Proveu:
%%% (A-->C\/B) /\ (B-->D\/A) ==> A/\B-->C/\D

   % Normalitzacio
   1: A-->C\/B  Premissa;        % 1ra premissa
      A\/(C\/B);
      A\/C\/B;

   2: B-->D\/A  Premissa;        % 2na. premissa
      B\/(D\/A);
      B\/D\/A;

   3: (A/\B-->C/\D)  Premissa;   % Negacio conclusio
      (A/\B)/\(C/\D);
      (A/\B)/\(C\/D);
      A/\B/\(C\/D);


   % Clausules
   C1: A\/C\/B per 1;
   C2: B\/D\/A per 2;
   C3: A         per 3;
   C4: B         per 3;
   C5: C\/D    per 3;

   % Resolucio
   R1: C\/B   per C3,C1;
   R2: C       per R1,C4;
   R3: D      per R2,C5;
   R4: B\/A  per R3,C2;
   R5: B      per R4,C3;
   R6: 0       per R5,C4.





%%% Proveu:
%%%    (!X(?Z P(X,Z) --> ?Y(Q(Y)/\R(X,Y))))
%%%    /\ (!Y(Q(Y) --> !X(R(X,Y)-->Q(X))))
%%%    ==> ?XQ(X) --> ?YP(Y,Y)

   % Normalitzacio
   1: !X(?Z P(X,Z) --> ?Y(Q(Y)/\R(X,Y)))  Premissa;   % 1ra.
      !X(?Z P(X,Z) \/ ?Y(Q(Y)/\R(X,Y)));
      !X(!Z P(X,Z) \/ ?Y(Q(Y)/\R(X,Y)));
      !X(!Z P(X,Z) \/ (Q(f(X))/\R(X,f(X))));
      !X!Z(P(X,Z) \/ (Q(f(X))/\R(X,f(X))));
      !X!Z((P(X,Z)\/Q(f(X))) /\ (P(X,Z)\/R(X,f(X))));

   2: !Y(Q(Y) --> !X(R(X,Y)-->Q(X)))  Premissa;       % 2na.
      !Y(Q(Y) \/ !X(R(X,Y)-->Q(X)));
      !Y!X(Q(Y) \/ (R(X,Y)-->Q(X)));
      !Y!X(Q(Y) \/ (R(X,Y)\/Q(X)));
      !Y!X(Q(Y)\/R(X,Y)\/Q(X));

   3: (?XQ(X) --> ?YP(Y,Y))  Premissa;  % Negacio conclusio
      ?XQ(X) /\ ?YP(Y,Y);
      ?XQ(X) /\ !Y P(Y,Y);
      Q(a) /\ !Y P(Y,Y);
      !Y(Q(a) /\ P(Y,Y));


   % Clausules
   C1: (P(X,Z)\/Q(f(X))) /\ (P(X,Z)\/R(X,f(X))) per 1;
       P(X,Z)\/Q(f(X));

   C2: (P(X,Z)\/Q(f(X))) /\ (P(X,Z)\/R(X,f(X))) per 1;
       P(X,Z)\/R(X,f(X));

   C3: Q(Y)\/R(X,Y)\/Q(X)  per 2;

   C4: Q(a) /\ P(Y,Y)   per 3;
       Q(a);

   C5: Q(a) /\ P(Y,Y)  per 3;
       P(Y,Y);
       

       
   % Resolucio
   R1: P(Y,Y) /\ (P(X1,Z1)\/Q(f(X1)))  per C5,C1;
       P(Y,Y) /\ (P(Y,Y)\/Q(f(Y)));                  % X1:=Y, Z1:=Y, per tot Y
       Q(f(Y));                                       % resolucio

   R2: Q(f(Y)) /\ (Q(Y2)\/R(X2,Y2)\/Q(X2))  per R1,C3;
       Q(f(Y)) /\ (Q(f(Y))\/R(X2,f(Y))\/Q(X2));           % Y2:=f(Y), per tot X2,Y
       R(X2,f(Y))\/Q(X2);                                  % resolucio

   R3: (R(X,f(Y))\/Q(X)) /\ (P(X3,Z3)\/R(X3,f(X3)))  per R2,C2;
       (R(X,f(X))\/Q(X)) /\ (P(X,Z3)\/R(X,f(X)));         % Y:=X, X3:=X, per tot X,Z3
       P(X,Z3)\/Q(X);                                      % resolucio

   R4: (P(X,Z)\/Q(X)) /\ P(Y4,Y4)  per R3,C5;
       (P(X,X)\/Q(X)) /\ P(X,X);                      % Y4:=X, Z:=X, per tot X
       Q(X);                                           % resolucio

   R5: Q(X) /\ Q(a)  per R4,C4;
       Q(a) /\ Q(a);           % X:=a
       0.                       % resolucio
